/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the UserPermissions type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UserPermissions{}

// UserPermissions struct for UserPermissions
type UserPermissions struct {
	Organizations []ObjectPermission `json:"organizations,omitempty"`
	Channels []ObjectPermission `json:"channels,omitempty"`
}

// NewUserPermissions instantiates a new UserPermissions object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserPermissions() *UserPermissions {
	this := UserPermissions{}
	return &this
}

// NewUserPermissionsWithDefaults instantiates a new UserPermissions object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserPermissionsWithDefaults() *UserPermissions {
	this := UserPermissions{}
	return &this
}

// GetOrganizations returns the Organizations field value if set, zero value otherwise.
func (o *UserPermissions) GetOrganizations() []ObjectPermission {
	if o == nil || IsNil(o.Organizations) {
		var ret []ObjectPermission
		return ret
	}
	return o.Organizations
}

// GetOrganizationsOk returns a tuple with the Organizations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserPermissions) GetOrganizationsOk() ([]ObjectPermission, bool) {
	if o == nil || IsNil(o.Organizations) {
		return nil, false
	}
	return o.Organizations, true
}

// HasOrganizations returns a boolean if a field has been set.
func (o *UserPermissions) HasOrganizations() bool {
	if o != nil && !IsNil(o.Organizations) {
		return true
	}

	return false
}

// SetOrganizations gets a reference to the given []ObjectPermission and assigns it to the Organizations field.
func (o *UserPermissions) SetOrganizations(v []ObjectPermission) {
	o.Organizations = v
}

// GetChannels returns the Channels field value if set, zero value otherwise.
func (o *UserPermissions) GetChannels() []ObjectPermission {
	if o == nil || IsNil(o.Channels) {
		var ret []ObjectPermission
		return ret
	}
	return o.Channels
}

// GetChannelsOk returns a tuple with the Channels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserPermissions) GetChannelsOk() ([]ObjectPermission, bool) {
	if o == nil || IsNil(o.Channels) {
		return nil, false
	}
	return o.Channels, true
}

// HasChannels returns a boolean if a field has been set.
func (o *UserPermissions) HasChannels() bool {
	if o != nil && !IsNil(o.Channels) {
		return true
	}

	return false
}

// SetChannels gets a reference to the given []ObjectPermission and assigns it to the Channels field.
func (o *UserPermissions) SetChannels(v []ObjectPermission) {
	o.Channels = v
}

func (o UserPermissions) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UserPermissions) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Organizations) {
		toSerialize["organizations"] = o.Organizations
	}
	if !IsNil(o.Channels) {
		toSerialize["channels"] = o.Channels
	}
	return toSerialize, nil
}

type NullableUserPermissions struct {
	value *UserPermissions
	isSet bool
}

func (v NullableUserPermissions) Get() *UserPermissions {
	return v.value
}

func (v *NullableUserPermissions) Set(val *UserPermissions) {
	v.value = val
	v.isSet = true
}

func (v NullableUserPermissions) IsSet() bool {
	return v.isSet
}

func (v *NullableUserPermissions) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserPermissions(val *UserPermissions) *NullableUserPermissions {
	return &NullableUserPermissions{value: val, isSet: true}
}

func (v NullableUserPermissions) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserPermissions) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


